﻿Public Class ReverseGrid
    Public CellSize As Integer
    Public Count As Integer

    Public Sub Draw(ByVal g As Graphics)
        Dim k As Integer
        Dim BorderPen As New Pen(Color.FromArgb(25, 25, 25), 2)

        For k = 0 To Count
            g.DrawLine(BorderPen, k * CellSize, 0, k * CellSize, Count * CellSize)
            g.DrawLine(BorderPen, 0, k * CellSize, Count * CellSize, k * CellSize)
        Next
        For Y = 0 To Count - 1
            For X = 0 To Count - 1
                Cells(X, Y).Draw(g)
            Next
        Next
    End Sub

    Dim m_Cells(,) As Cell

    Public Sub New(ByVal rownum As Integer, ByVal gridsiz As Integer)
        Dim X As Integer
        Dim Y As Integer

        Me.Count = rownum
        Me.CellSize = CInt(gridsiz / rownum)
        ReDim m_Cells(Count - 1, Count - 1)
        For X = 0 To Count - 1
            For Y = 0 To Count - 1
                m_Cells(X, Y) = New Cell(Me, New Point(X, Y))
            Next
        Next
    End Sub

    Public Property Cells(ByVal X As Integer, ByVal Y As Integer) As Cell
        Get
            Return m_Cells(X, Y)
        End Get
        Set(ByVal value As Cell)
            m_Cells(X, Y) = value
        End Set
    End Property

    Public Function CellFromPoint(ByVal X As Integer, ByVal Y As Integer) As Cell
        Dim ThisCell As Cell

        If X < 0 OrElse X >= Count * CellSize Then
            Return Nothing
        End If
        If Y < 0 OrElse Y >= Count * CellSize Then
            Return Nothing
        End If
        ThisCell = Cells(X \ CellSize, Y \ CellSize)

        Return ThisCell
    End Function
End Class